#include <windows.h>
#include <commctrl.h>

/* Declare Window procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

/* Declare EnumWindowsProc - Enumerates top-level window handles */
BOOL CALLBACK EnumWindowsProc(HWND hwnd,LPARAM lParam);
BOOL CALLBACK EnumWindowsProc2(HWND hwnd,LPARAM lParam);


/* Make the class name into a global variable  */
char szClassName[ ]				=		"Password Revealer";

int WINAPI WinMain (HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil)
{
	InitCommonControls();

	/* This is the handle for our window */
	HWND hwnd;
	/* Here messages to the application are saved */
	MSG messages;
	/* Data structure for the windowclass */
    WNDCLASSEX wincl;

	/* The Window structure */
	wincl.hInstance				=		hThisInstance;

	wincl.lpszClassName			=		szClassName;

	/* This function is called by windows */
	wincl.lpfnWndProc			=		WindowProcedure;

	/* Catch double-clicks */
	wincl.style = CS_DBLCLKS;

	wincl.cbSize = sizeof (WNDCLASSEX);

	/* Use default icon and mouse-pointer */
	wincl.hIcon					=		LoadIcon (NULL, IDI_APPLICATION);
	wincl.hIconSm				=		LoadIcon (NULL, IDI_APPLICATION);
	wincl.hCursor				=		LoadCursor (NULL, IDC_ARROW);
	/* No menu */
	wincl.lpszMenuName			=		NULL;
	/* No extra bytes after the window class */
	wincl.cbClsExtra			=		0;
	/* Structure or the window instance */
	wincl.cbWndExtra			=		0;
	/* Use Windows's default color as the background of the window */
	wincl.hbrBackground			=		(HBRUSH)(COLOR_3DFACE+1);

	/* Register the window class, and if it fails quit the program */
	if(!RegisterClassEx (&wincl))
	{
		 return 0;
	}

	/*
	 * The class is registered so let's create the window.
	 */
	hwnd						=		CreateWindowEx
	(
		0,										/* Extended possibilites for variation */
		szClassName,							/* Classname */
		szClassName,							/* Title Text */
		WS_POPUPWINDOW|WS_CAPTION,				/* Popup window with title bar */
		CW_USEDEFAULT,							/* Windows decides the position */
		CW_USEDEFAULT,							/* Where the window ends up on the screen */
		250,									/* The programs width */
		150,									/* Hheight in pixels */
		HWND_DESKTOP,							/* The window is a child-window to desktop */
		NULL,									/* No menu */
		hThisInstance,							/* Program Instance handler */
		NULL									/* No Window Creation data */
	);

	/*
	 * Add a button to the window.
	 */
	CreateWindowEx
	(
		0,										/* more or 'extended' styles */
		TEXT("BUTTON"),							/*'class' of control to create */
		TEXT("Reveal Passwords"),				/* the control caption */
		WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,	/* control style: how it looks */
		40,										/* control position: left */
		75,										/* control position: top */
		170,									/* control width */
		30,										/* control height */
		hwnd,									/* parent window handle */
		NULL,									/* control's ID */
		hThisInstance,							/* application instance */
		NULL
	);

	/*
	 * Add a label to the window.
	 */
	CreateWindowEx
	(
		0,										/* more or 'extended' styles */
		TEXT("STATIC"),							/*'class' of control to create */
		TEXT("Click below to reveal any hidden on-screen passwords"),				/* the control caption */
		WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,	/* control style: how it looks */
		25,										/* control position: left */
		10,										/* control position: top */
		200,									/* control width */
		60,										/* control height */
		hwnd,									/* parent window handle */
		NULL,									/* control's ID */
		hThisInstance,							/* application instance */
		NULL
	);

	/* Make the window visible on the screen */
	ShowWindow (hwnd, nFunsterStil);

	/*
	 * Run the message loop. It will run until GetMessage() returns 0
	 */
	while (GetMessage (&messages, NULL, 0, 0))
	{
		/* Translate virtual-key messages into character messages */
		TranslateMessage(&messages);
		/* Send message to WindowProcedure */
		DispatchMessage(&messages);
	}

	/* The program return-value is 0 - The value that PostQuitMessage() gave */
	return messages.wParam;
}


/*
 * This function is called by the Windows function DispatchMessage()
 */
LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	/* Handle messages */
	switch(message)
	{
		case WM_COMMAND:
			 /* If button is clicked. */
			if(HIWORD(wParam) == BN_CLICKED)
			{
			 	/* Call every window */
				EnumWindows(EnumWindowsProc, 0);
			}
			break;

		case WM_DESTROY:
			/* Send a WM_QUIT to the message the queue. */
			PostQuitMessage(0);
			break;

		/* We don't deal with these messages. */
		default:
			return DefWindowProc (hwnd, message, wParam, lParam);
	}

	return 0;
}


/*
 * This function receives top level window handles and passes them onto
 * EnumWindowsProc2 to reset any masks on input boxes.
 */
BOOL CALLBACK EnumWindowsProc(HWND hwnd ,LPARAM lParam)
{
	/* call every child window (to find edit boxes) */
	EnumChildWindows(hwnd, EnumWindowsProc2, lParam);

	/* Continue enumeration. */
	return TRUE;
}


/*
 * This function clears the password character from the input box,
 * thus making the text readable.
 */
BOOL CALLBACK EnumWindowsProc2(HWND hwnd, LPARAM)
{
	/* Set he password character to 0, so that the text is revealed. */
	::SendMessage(hwnd, EM_SETPASSWORDCHAR, 0, 0);

	/* Invalidate the area */
	InvalidateRect(hwnd, NULL, FALSE);

	/* Continue enumeration. */
	return TRUE;
}
